; Mult16x8.asm multipliziert eine 16bit Zahl mit einer 8bit Zahl zu einem
; 24-Bit-Ergebnis
;

; Ablauf des Multiplizierens:
;
; 1.Multiplikator 2 wird bitweise nach rechts in das
;   Carry-Bit geschoben. Wenn es eine Eins ist, dann
;   wird die Zahl in Multiplikator 1 zum Ergebnis dazu
;   gezhlt, wenn es eine Null ist, dann nicht.
; 2.Nach dem Addieren wird Multiplikator 1 durch Links-
;   schieben mit 2 multipliziert.
; 3.Wenn Multiplikator 2 nach dem Schieben nicht Null
;   ist, dann wird wie oben weiter gemacht. Wenn er Null
;   ist, ist die Multplikation beendet.


MULT16x8:
		mov temp1,rm1l		;testen, ob eine Mul mit 0 vorliegt
		or temp1,rm1h
		tst temp1	
		breq MulNull
		tst rm2
		breq MulNull
		
		
MulInitReg:
		ser temp1		
		mov rmh,temp1	;rmh setzen		
		sbrs rm1h,7		;wenn Mul2 pos. (Bit7 von rm1h=0) dann lsche rmh
		clr rmh		
		clr re1l 		;Ergebnis auf Null setzen
		clr re1h
		clr re2l
		

MULT16x8a:
		clc
		ror rm2 	
		brcc MULT16x8b 	;springe, wenn niedrigstes Bit eine
	 					;Null ist, ber das Addieren hinweg

		add re1l,rm1l 	;addiere LSB von rm1 zum Ergebnis
		adc re1h,rm1h 	;addiere Carry und MSB von rm1
		adc re2l,rmh

MULT16x8b:

		clc 
		rol rm1l 
		rol rm1h
		rol rmh 

		tst rm2 		;alle bits Null?
		brne MULT16x8a 	;wenn nicht null, dann weitermachen
		
		ret

MulNull:
		clr re1l
		clr re1h
		clr re2l
		ret

;********************************************************************************

div16d8:
		mov temp1,rm1l		;testen, ob eine Div mit 0 vorliegt
		or temp1,rm1h
		tst temp1	
		breq DivNull
		tst rm2
		breq DivNull
		
DivInitReg:
		ser temp1		
		mov rmh,temp1		;rmh setzen		
		sbrs rm1h,7			;wenn Mul2 pos. (Bit7 von rm1h=0) dann lsche rmh
		clr rmh 			; Leere Hilfsregister
		clr re1h 			; Leere Ergebnisregister
		clr re1l 			; (Ergebnisregister dient auch als
		inc re1l 			; Zhler bis 16! Bit 1 auf 1 setzen)

div16d8a:
		clc 				; Carry-Bit leeren
		rol rm1l 			; nchsthheres Bit des Dividenten
		rol rm1h 			; in das Hilfsregister rotieren
		rol rmh 			; (entspricht Multipliklation mit 2)
		brcs div16d8b 		; Eine 1 ist herausgerollt, ziehe ab
		cp rmh,rm2 			; Divisionsergebnis 1 oder 0?
		brcs div16d8c 		; berspringe Subtraktion, wenn kleiner
div16d8b:
		sub rmh,rm2			; Subtrahiere Divisor
		sec 				; Setze carry-bit, Ergebnis ist eine 1
		rjmp div16d8d 		; zum Schieben des Ergebnisses
div16d8c:
		clc 				; Lsche carry-bit, Ergebnis ist eine 0
div16d8d:
		rol re1l 			; Rotiere carry-bit in das Ergebnis
		rol re1h
		brcc div16d8a 		; solange Nullen aus dem Ergebnis
	 						; rotieren: weitermachen
							; Ende der Division erreicht
		ret

DivNull:
		clr re1l
		clr re1h
		clr re2l
		ret