ADCCC:		
		push temp1
		in temp1,SREG
		push temp1

		in	temp1,ADCH				;Messwert holen

		cpi Kanal,0x20
		breq Kanal0
		cpi Kanal,0x21
		breq Kanal1
		cpi Kanal,0x22
		breq Kanal2
		cpi Kanal,0x23
		breq Kanal3
		cpi Kanal,0x24
		breq Kanal4
		rjmp ADCCCEnde
		

Kanal0:	
		sts SSSollwert,temp1	
		rjmp ADCCCEnde
							
Kanal1:	sts SSIstwert,temp1			;bei Kanal1 = AD-Wert auf Istwert schreiben		
		rjmp ADCCCEnde

Kanal2:	sts SSKp,temp1				;bei Kanal2 = AD-Wert auf Kp schreiben		
		rjmp ADCCCEnde		

Kanal3:	sts SSKi,temp1				;bei Kanal3 = AD-Wert auf Ki schreiben	
		rjmp ADCCCEnde	
		
Kanal4:	sts SSKd,temp1				;bei Kanal4 = AD-Wert auf Kd schreiben		
		;rcall TC0OV					;Berechnung wird durchgefhrt
		rjmp ADCCCEnde

ADCCCEnde:
		pop temp1
		out SREG,temp1
		pop temp1	
		reti
		


;*******************************************************************************

TC0OV:		
		push temp1
		in temp1,SREG
		push temp1
		
		inc Kanal
		cpi Kanal,0x25		;0x25
		brne ADMUXAusgabe
		ldi Kanal,0b00100000	;Kanal 0 einstellen
ADMUXAusgabe:
		out ADMUX, Kanal
	
		ldi temp1, 0b11001110		;Start Conversion
		out ADCSR, temp1				

		pop temp1
		out SREG,temp1
		pop temp1	
		reti	


;***************************************************************************

TC1OV:	
		push temp1
		push temp2
		push temp3
		push temp4
		
		in temp1,SREG
		push temp1	
		
		ldi temp1,Timer1H			;Timer1 wieder nachladen
		ldi temp2,Timer1L
		out TCNT1H,temp1
		out TCNT1L,temp2
		rjmp BerError
			
BerError:
		lds temp1,SSSollwert		;Sollwert - Istwert = Fehler
		lds temp2,SSIstwert
		sub temp1, temp2
		mov temp3,temp1					
		brcc ErrPos
ErrNeg:		
		ldi temp2,255
		ldi temp4,255		
		cpi temp3,-MinErr 
		brlo NegLoGlMinErr
		ldi temp3,0
		ldi temp4,0				
		rjmp ErrSp
ErrPos:	
		ldi temp2,0
		ldi temp4,0	
		cpi temp3,MinErr
		brge PosGrGlMinErr
		ldi temp3,0						
		rjmp ErrSp

PosGrGlMinErr:
		subi temp3,MinErr	
		rjmp ErrSp

NegLoGlMinErr:
		subi temp3,-MinErr	
		rjmp ErrSp

ErrSp:	
		sts SSErrAnzL,temp1
		sts SSErrAnzH,temp2
		sts SSErrL,temp3
		sts SSErrH,temp4
		rjmp BerInt
		
BerInt:
		lds rm1l,SSErrL				;Int = Int + Err*t
		lds rm1h,SSErrH
		lds rm2, SSt
		rcall Mult16x8
		lds temp1,SSIntT1L
		lds temp2,SSIntT1H
		;lds temp3,rm2l
		add re1l ,temp1
		adc re1h ,temp2
		sts SSIntL, re1l
		sts SSIntH, re1h
		rjmp BerDiff		

BerDiff:	
		lds temp1,SSErrL			;Diff = (Err - ErrT-1)/t
		lds temp2,SSErrH
		lds temp3,SSErrT1L
		lds temp4,SSErrT1H
		sts SSErrT1L, temp1			;ErrT-1 = Err
		sts SSErrT1H, temp2
		
		sub temp1, temp3
		sbc temp2, temp4
		mov rm1l,temp1
		mov rm1h,temp2
		lds temp1,SSt
		mov rm2, temp1
		rcall div16d8
		sts SSDiffL, re1l
		sts SSDiffH, re1h		
		rjmp BerPout

BerPout:
		lds rm1l, SSErrL			;Pout = P*Kp
		lds rm1h, SSErrH
		lds rm2, SSKp
		rcall Mult16x8
		sts	SSPoutL, re1l
		sts SSPoutH, re1h
		rjmp BerIout

BerIout:		
		lds rm2, SSKi
		tst rm2
		brne IntMulti				;wenn Ki=0 dann werden, die bis jetzt aufintegrierten
		ldi temp1,0					;Werte in SSInH:L gelscht
		sts SSIntL,temp1
		sts SSIntH,temp1
IntMulti:
		lds rm1l, SSIntL			;Iout = I*Ki
		lds rm1h, SSIntH	
		rcall Mult16x8
		sts	SSIoutL, re1l
		sts SSIoutH, re1h
		rjmp BerDout

BerDout:
		lds rm1l, SSDiffL			;Dout = D*Kd
		lds rm1h, SSDiffH
		lds rm2, SSKd
		rcall Mult16x8
		sts	SSDoutL, re1l
		sts SSDoutH, re1h
		rjmp BerOut

BerOut: lds temp1,SSPoutL			;Out = Pout + Iout + Dout
		lds temp2,SSPoutH
		lds temp3,SSIoutL
		lds temp4,SSIoutH
		add temp1,temp3
		adc temp2,temp4
		lds temp3,SSDoutL
		lds temp4,SSDoutH
		add temp1,temp3
		adc temp2,temp4								;
								;16bit Out-Wert auf Maximalwert und Minimalwert begrenzen
		sbrc temp2,7			;testen ob die Zahl Negativ ist
		rjmp ZahlNegativ		

ZahlPositiv:
		cpi temp2,0				;Zahl=pos: Wenn HByte = 0 dann Kontrolle von Low-Byte
		breq HByteNull
		rjmp PosMax
HByteNull:
		cpi temp1,Maxwert + 1 
		brlo ZahlImBereich
		rjmp PosMax
ZahlNegativ:
		cpi temp2,0xFF
		breq HByte0xFF
		rjmp NegMin
HByte0xFF:
		cpi temp1,Minwert - 1
		brlo NegMin
		rjmp ZahlImBereich

PosMax:	ldi temp1,Maxwert
		ldi temp2,0
		rjmp ZahlNichtImBereich
NegMin:	ldi temp1,Minwert
		ldi temp2,-1
		rjmp ZahlNichtImBereich


ZahlNichtImBereich:					;ist die Zahl nicht im Bereich, wird der neue Int-Wert
		lds temp4,SSIntT1L			;mit dem alten berschrieben
		sts SSIntL,temp4
		lds temp4,SSIntT1H
		sts SSIntH,temp4
		rjmp Ausgabe

ZahlImBereich:						;ist die Zahl im Bereich, wird der alte Int-Wert
		lds temp4,SSIntL			;mit dem neuen geladen
		sts SSIntT1L,temp4
		lds temp4,SSIntH
		sts SSIntT1H,temp4
		rjmp Ausgabe

Ausgabe:		
		sts SSOutL, temp1
		sts SSOutH, temp2	
		
		ldi temp3,0x80				;zum Anzeigewert die Konstante 128 addieren und
		add temp1,temp3				;damit die Spannung auf 2,5V heben im Nullzustand
		out OCR2, temp1

		rcall AnzeigeZeile2
		rcall AnzeigeZeile1
	
		pop temp1
		out SREG,temp1				;aktuller Wert von RAM holen und in OCR2 schreiben
		pop temp4
		pop temp3
		pop temp2
		pop temp1	
		reti ;reti

;*******************************************************************************
