.include "M8def.inc"        

.DEF rm1l = R0 		
.DEF rm1h = R1
.Def rmh = R2		
.DEF rm2 = R3 		
.DEF re1l = R4 		
.DEF re1h = R5 		
.Def re2l = R6		


.def temp1 = r16
.def temp2 = r17
.def temp3 = r18
.def temp4 = r19

.def rBin1L = r20
.def rBin1H = r21
.def rBin2L = r22
.def rBin2H = r23
.def rmp = r24

.def Kanal = r25

.equ Timer1H = 0xB6
.equ Timer1L = 0xC2

.equ SSSollwert = 0x60
.equ SSIstwert = 0x61
.equ SSErrL = 0x62
.equ SSErrH = 0x63
.equ SSErrT1L = 0x64
.equ SSErrT1H = 0x65
.equ SSIntL = 0x66
.equ SSIntH = 0x67
.equ SSDiffL = 0x68
.equ SSDiffH = 0x69
.equ SSPoutL = 0x6A
.equ SSPoutH = 0x6B
.equ SSIoutL = 0x6C
.equ SSIoutH = 0x6D
.equ SSDoutL = 0x6E
.equ SSDoutH = 0x6F
.equ SSt = 0x70
.equ SSOutL = 0x71
.equ SSOutH = 0x72
.equ SSKp = 0x73
.equ SSKi = 0x74
.equ SSKd = 0x75

.equ SSEKp = 0x0000
.equ SSEKi = 0x0001
.equ SSEKd = 0x0002
		
.CSEG
		rjmp ProgStart
		reti
		reti
		reti
		reti 
		reti
		reti
		reti
		rjmp TC1OV
		rjmp TC0OV
		reti
		reti
		reti
		reti
		rjmp ADCCC


ProgStart:
		ldi temp1, low(RAMEND)  
        out SPL, temp1
		ldi temp1, high(RAMEND)  
        out SPH, temp1	

        	
		ldi temp1, 0			;Speicherpltze initialisieren
		sts SSIntL,temp1
		sts SSIntH,temp1
		sts SSErrT1L,temp1
		sts SSErrT1H,temp1
		sts SSOutL,temp1
		sts SSOutH,temp1
		ldi temp1, 1
		sts SSt,temp1


		ldi temp1,0b00111111    ;PortD:
        out DDRD, temp1
		ldi temp1,0b00001111	;PortB:
		out DDRB, temp1
		
		
		
		;rjmp InitTimer0
		rjmp InitLCD
		
		
InitLCD:	   
        rcall lcd_init     		;Display initialisieren
        rcall lcd_clear    		;Display lschen  		   
		rcall AusgText			;Text fr erste Zeile ausgeben
		rjmp InitTimer0


InitTimer0:	
		in temp1, TIMSK			;TOIE0 in TIMSK setzen und damit Timer0 Int freigeben
		ori temp1, 0b00000001
		out TIMSK, temp1
		sei
		ldi temp1, 0b00000101	;Vorteiler auf 1024 setzen -> 21,8453ms
		out TCCR0, temp1		;Timer0 fr AD-Werte einlesen
		rjmp InitTimer1	

InitTimer1:	
		in temp1,TIMSK			;TOIE1 in TIMSK setzen und damit Timer1 Int freigeben
		ori temp1,0b00000100
		out TIMSK,temp1			;Timer1 laden -> Interrupttime = 100ms
		ldi temp1,Timer1H		;Timer1 fr Berechnung der PID-Regelung
		ldi temp2,Timer1L
		out TCNT1H,temp1
		out TCNT1L,temp2
		ldi temp1,0b00000011	;Vorteiler auf 64 setzen		
		out TCCR1B,temp1		;CTC1 setzen 		
		rjmp InitTimer2
		
InitTimer2:			
		lds temp1,SSOutL
		out OCR2, temp1			;OCR2 mit Anfangswerten laden
		ldi temp1,0b01101101	;WGM21:0 auf FastPWNM stellen; COM21:0 auf clear bei
		out TCCR2,temp1			;compare und set bei TOP stellen; Prescaler = 128 
		rjmp InitADC

InitADC:			
		 
		ldi temp1, 0b10001110	;ADC Initialisierung:ADEN freigeben,ADIE freigeben,Vorteiler auf 64
		out ADCSR, temp1
	
		rjmp Nixtun

Nixtun:		
		rjmp Nixtun

;*******************************************************************************
ADCCC:		
		push temp1
		in temp1,SREG
		push temp1

		in	temp1,ADCH

		cpi Kanal,0x20
		breq Kanal0
		cpi Kanal,0x21
		breq Kanal1
		cpi Kanal,0x22
		breq Kanal2
		cpi Kanal,0x23
		breq Kanal3
		cpi Kanal,0x24
		breq Kanal4
		rjmp ADCCCEnde
		

Kanal0:	sts SSSollwert,temp1		;bei Kanal0 = AD-Wert auf Sollwert schreiben
		rjmp ADCCCEnde
							
Kanal1:	sts SSIstwert,temp1			;bei Kanal1 = AD-Wert auf Istwert schreiben
		rjmp ADCCCEnde

Kanal2:	sts SSKp,temp1				;bei Kanal2 = AD-Wert auf Kp schreiben
		rjmp ADCCCEnde		

Kanal3:	sts SSKi,temp1				;bei Kanal3 = AD-Wert auf Ki schreiben
		rjmp ADCCCEnde	
		
Kanal4:	sts SSKd,temp1				;bei Kanal4 = AD-Wert auf Kd schreiben		
		rjmp ADCCCEnde

ADCCCEnde:
	
		pop temp1
		out SREG,temp1
		pop temp1	
		reti
		


;*******************************************************************************

TC0OV:		
		push temp1
		in temp1,SREG
		push temp1
		
		inc Kanal
		cpi Kanal,0x25
		brne ADMUXAusgabe
		ldi Kanal,0b00100000
ADMUXAusgabe:
		out ADMUX, Kanal
		ldi temp1, 0b11001110		;Start Conversion
		out ADCSR, temp1
		
		pop temp1
		out SREG,temp1
		pop temp1	
		reti	


;***************************************************************************

TC1OV:						
		push temp1
		push temp2
		push temp3
		push temp4
		
		in temp1,SREG
		push temp1	
		
		ldi temp1,Timer1H			;Timer1 wieder nachladen
		ldi temp2,Timer1L
		out TCNT1H,temp1
		out TCNT1L,temp2
		rjmp BerError
			
BerError:
		lds temp1,SSSollwert		;Sollwert - Istwert = Fehler
		lds temp2,SSIstwert
		sub temp1, temp2		
		brcc ErgPos		
		ldi temp2,0b11111111
		rjmp ErgSp
Ergpos:	ldi temp2,0b00000000
		rjmp ErgSp
ErgSp:	sts SSErrL,temp1			
		sts SSErrH,temp2
		rjmp BerInt
		
BerInt:
		lds rm1l,SSErrL				;Int = Int + Err*t
		lds rm1h,SSErrH
		lds rm2, SSt
		rcall Mult16x8
		lds temp1,SSIntL
		lds temp2,SSIntH
		;lds temp3,rm2l
		add re1l ,temp1
		adc re1h ,temp2
		sts SSIntL, re1l
		sts SSIntH, re1h
		rjmp BerDiff		

BerDiff:	
		lds temp1,SSErrL			;Diff = (Err - ErrT-1)/t
		lds temp2,SSErrH
		lds temp3,SSErrT1L
		lds temp4,SSErrT1H
		sts SSErrT1L, temp1			;ErrT-1 = Err
		sts SSErrT1H, temp2
		
		sub temp1, temp3
		sbc temp2, temp4
		mov rm1l,temp1
		mov rm1h,temp2
		lds temp1,SSt
		mov rm2, temp1
		rcall div16d8
		sts SSDiffL, re1l
		sts SSDiffH, re1h		
		rjmp BerPout

BerPout:
		lds rm1l, SSErrL			;Pout = P*Kp
		lds rm1h, SSErrH
		lds rm2, SSKp
		rcall Mult16x8
		sts	SSPoutL, re1l
		sts SSPoutH, re1h
		rjmp BerIout

BerIout:						
		lds rm1l, SSIntL			;Iout = I*Ki
		lds rm1h, SSIntH
		lds rm2, SSKi
		rcall Mult16x8
		sts	SSIoutL, re1l
		sts SSIoutH, re1h
		rjmp BerDout

BerDout:
		lds rm1l, SSDiffL			;Dout = D*Kd
		lds rm1h, SSDiffH
		lds rm2, SSKd
		rcall Mult16x8
		sts	SSDoutL, re1l
		sts SSDoutH, re1h
		rjmp BerOut

BerOut: lds temp1,SSPoutL			;Out = Pout + Iout + Dout
		lds temp2,SSPoutH
		lds temp3,SSIoutL
		lds temp4,SSIoutH
		add temp1,temp3
		adc temp2,temp4
		lds temp3,SSDoutL
		lds temp4,SSDoutH
		add temp1,temp3
		adc temp2,temp4
		sts SSOutL, temp1
		sts SSOutH, temp2	
		
		lds temp1,SSOutL		;aktuller Wert von RAM holen und in OCR2 schreiben
		out OCR2, temp1 
		rcall Anzeige

		
		pop temp1
		out SREG,temp1
		pop temp4
		pop temp3
		pop temp2
		pop temp1	
		reti


;********************************************************************************					





;***************************************************************************


tabelle1:
.db	"           Err   Out"
;    12345678901234567890
.include "lcd-routines.asm"            ;LCD-Routinen werden hier eingefgt
.include "D:\Microcontroller\Atmel AVR\Math\konvert.asm"
.include "C:\Programme\Atmel\AVR Tools\AvrStudio4\Mathematik.asm"