.include "M8def.inc"        

.DEF rm1l = R0 		
.DEF rm1h = R1
.Def rmh = R2		
.DEF rm2 = R3 		
.DEF re1l = R4 		
.DEF re1h = R5 		
.Def re2l = R6	

;.def Eingabezeile = R7	


.def temp1 = r16
.def temp2 = r17
.def temp3 = r18
.def temp4 = r19

.def rBin1L = r20
.def rBin1H = r21
.def rBin2L = r22
.def rBin2H = r23
.def rmp = r24

.def Kanal = r25


.def LCD_CursorPos = r29

.equ Timer1H = 0xB6			;Nachladewerte fr Timer1 2^16-46786 = 18750 ->100ms Refreshzeit bei 12MHz
.equ Timer1L = 0xC2

.equ SSSollwert = 0x60		;RAM Speicherpltze fr verschiedene Werte
.equ SSIstwert = 0x61
.equ SSErrL = 0x62
.equ SSErrH = 0x63
.equ SSErrT1L = 0x64
.equ SSErrT1H = 0x65
.equ SSIntL = 0x66
.equ SSIntH = 0x67
.equ SSDiffL = 0x68
.equ SSDiffH = 0x69
.equ SSPoutL = 0x6A
.equ SSPoutH = 0x6B
.equ SSIoutL = 0x6C
.equ SSIoutH = 0x6D
.equ SSDoutL = 0x6E
.equ SSDoutH = 0x6F
.equ SSt = 0x70
.equ SSOutL = 0x71
.equ SSOutH = 0x72
.equ SSKp = 0x73
.equ SSKi = 0x74
.equ SSKd = 0x75
.equ SSErrAnzL = 0x76
.equ SSErrAnzH = 0x77
.equ SSIntT1L = 0x78
.equ SSIntT1H = 0x79

.equ SSEKp = 0x0000
.equ SSEKi = 0x0001
.equ SSEKd = 0x0002

.equ MaxWert = 127				;Maximumwert des Ausgangs
.equ MinWert = -128				;Minimumwert
.equ MinErr = 1				;Minimumwert bei dem die Berechnung durchgefhrt wird.
								;Ist die Diff. zw. Ist-u.Sollwert kleiner als dieser Wert
								;so wird berhaupt keine Berechnung durchgefhrt


		
.CSEG
		rjmp ProgStart
		reti		
		reti		
		reti
		reti 
		reti
		reti
		reti
		rjmp TC1OV				;Berechnung wird ausgefhrt
		rjmp TC0OV				;Start einer AD-Wandlung
		reti
		reti
		reti
		reti
		rjmp ADCCC				;AD-Wandlung durchgefhrt


ProgStart:
		ldi temp1, low(RAMEND)  
        out SPL, temp1
		ldi temp1, high(RAMEND)  
        out SPH, temp1

		ldi temp1,0b11110011    ;PortD:
        out DDRD, temp1
		ldi temp1,0b00001011	;PortB:
		out DDRB, temp1

		rcall InitRAM
		rcall InitLCD
		rcall InitTimer0		
		rcall InitTimer1
		rcall InitTimer2
		rcall InitADC
		
		sei

		rjmp Nixtun

Nixtun:		
								

		rjmp Nixtun

;*******************************************************************************
.include "C:\Programme\Atmel\AVR Tools\AvrStudio4\PID Regler1\PID InitRoutinen.asm"
.include "C:\Programme\Atmel\AVR Tools\AvrStudio4\PID Regler1\Mathematik.asm"
.include "C:\Programme\Atmel\AVR Tools\AvrStudio4\PID Regler1\LCD Routinen.asm"
.include "C:\Programme\Atmel\AVR Tools\AvrStudio4\PID Regler1\konvert.asm"
.include "C:\Programme\Atmel\AVR Tools\AvrStudio4\PID Regler1\PID IntRoutinen.asm"


StringZ1:	.db	"SW:    P   I   D    "
			;    12345678901234567890

StringZ2:	.db	"IW:    E:    O:     "
			;    12345678901234567890