.include "M8def.inc"        

.DEF rm1l = R0 		
.DEF rm1h = R1
.Def rmh = R2		
.DEF rm2 = R3 		
.DEF re1l = R4 		
.DEF re1h = R5 		
.Def re2l = R6

.def AnzString = R7
.def Zeile = R8


.def KeyboardF0 = R10		


.def temp1 = r16
.def temp2 = r17
.def temp3 = r18
.def temp4 = r19


.def rBin1L = r20
.def rBin1H = r21
.def rBin2L = r22
.def rBin2H = r23
.def rmp = r24

.def Kanal = r25

.def Bitzaehler = r26
.def KeyboardIn = r27
.def KeyboardBits = r28
.def LCD_CursorPos = r29

.equ Timer1H = 0xB6
.equ Timer1L = 0xC2

.equ SSSollwert = 0x60
.equ SSIstwert = 0x61
.equ SSErrL = 0x62
.equ SSErrH = 0x63
.equ SSErrT1L = 0x64
.equ SSErrT1H = 0x65
.equ SSIntL = 0x66
.equ SSIntH = 0x67
.equ SSDiffL = 0x68
.equ SSDiffH = 0x69
.equ SSPoutL = 0x6A
.equ SSPoutH = 0x6B
.equ SSIoutL = 0x6C
.equ SSIoutH = 0x6D
.equ SSDoutL = 0x6E
.equ SSDoutH = 0x6F
.equ SSt = 0x70
.equ SSOutL = 0x71
.equ SSOutH = 0x72
.equ SSKp = 0x73
.equ SSKi = 0x74
.equ SSKd = 0x75
.equ SSErrAnzL = 0x76
.equ SSErrAnzH = 0x77
.equ SSIntT1L = 0x78
.equ SSIntT1H = 0x79

.equ SSEKp = 0x0000
.equ SSEKi = 0x0001
.equ SSEKd = 0x0002

.equ MaxWert = 127
.equ MinWert = -128
.equ MinErr = 20

.equ AnzZeilen = 7

.equ BitF0 = 1
.equ BitE0 = 2
.equ CPosMinZ1 = 0x80
.equ CPosMaxZ1 = 0x93
.equ CPosMinZ2 = 0xC0
.equ CPosMaxZ2 = 0xD3
		
.CSEG

.CSEG
.ORG 000
		rjmp ProgStart
		rjmp ExInt0				;Clock von Keyboard
		rjmp ExInt1				;Data von Keyboard
		reti
		reti 
		reti
		reti
		reti
		reti
		reti
		reti
		reti
		reti
		reti
		reti
		
		
ProgStart:

		ldi temp1, low(RAMEND)  
        out SPL, temp1
		ldi temp1, high(RAMEND)  
        out SPH, temp1

		ldi temp1,0b11110011    ;PortD:		;Keyboardanschlsse auf Input
        out DDRD, temp1
		ldi temp1,0b00001111	;PortB:
		out DDRB, temp1
		

		;******************************
		;ldi LCD_CursorPos,0x80
		;ldi KeyboardIn,0xF0
		;rjmp ComPFDN
		
		;*******************************
		;rcall InitRAM
		rcall LCD_init
		rcall lcd_clear		
		rcall Zeile1
		rcall ControlLCD_CursorPos
		in temp1,MCUCR
		ori temp1, 0b00001010		;Ex.Int0 und Ext.Int1  auf fallende Flanke setzen
		out MCUCR,temp1
	
		
		ldi temp1,0b11111111		;INTF1:0 lschen
		out GIFR,temp1
		ori temp1,0b10000000		;Ex.Int1 freigeben
		out GICR,temp1
		
		clr Bitzaehler
		clr KeyboardBits
				
		sei							;Generell Interrups freigeben
Nixtun:	
		cbi portb,0
		cbi portb,1
		sbrc KeyboardBits,0
		sbi portb,0
		sbrc KeyboardBits,1
		sbi portb,1
		
					  
		rjmp Nixtun


ExInt0:
		push temp1
		cpi Bitzaehler,0
		breq IncBitZaehler
		cpi Bitzaehler,9
		breq IncBitZaehler
		cpi Bitzaehler,10
		breq KeyByteVoll
		clc							;hier fr BitZaehler 1-8
		sbic PIND,3					;wenn Keyboard Data = 1 dann Carry = 1
		sec
		ror KeyboardIn				;und ins KeyboardIn schieben
		rjmp IncBitzaehler
KeyByteVoll:
		clr Bitzaehler		

		
		cpi KeyboardIn,0xE0
		breq E0Erkannt				;testen auf E0		

		cpi KeyboardIn,0xF0
		breq F0Erkannt				;testen auf F0
	
		ldi temp1,0
		ldi zl,Low(LUTKey*2)
		ldi zh,High(LUTKey*2)
		add zl,KeyboardIn			;Z-Reg. mit Adr von LUTKey laden
		adc zh,temp1
		lpm	temp1,Z					;Rckgabewert der LUT in temp1
		
		sbrs KeyboardBits,0			;Prfen auf F0Bit,wenn TRUE dann weiter sonst Abbruch 	
		rjmp IntFreigeben
		cbr KeyboardBits,BitF0		
		sbrc KeyboardBits,1			;Prfen auf E0Bit,wenn TRUE dann E0Zeichen (Sonderzeichen)
		rjmp Command		
		cpi temp1,0xFF				;Prfen, ob Command
		breq Command		
		rcall LCD_Data		
		rjmp IntFreigeben

Command:		
		cbr KeyboardBits,BitE0
		ldi temp1,0
		ldi temp3,Low(LUTCommands)
		ldi temp4,High(LUTCommands)
		add temp3,KeyboardIn
		adc temp4,temp1
		push temp3					;Rckgabe
		push temp4
		ret							;Aufruf der neuen auf dem Stack ablegten Adresse
		

		
F0Erkannt:
		sbr KeyboardBits,BitF0
		rjmp IntFreigeben
E0Erkannt:
		sbr KeyboardBits,BitE0
		rjmp IntFreigeben
	

IntFreigeben:
		ldi temp1,0b11111111
		out GIFR,temp1				;INTF1:0 lschen
		ldi temp1,0b10000000		;INT1 freigeben, INT0 sperren
		out GICR, temp1				
		pop temp1
		reti
IncBitzaehler:
		inc Bitzaehler
		pop temp1
		reti

ExInt1:
		push temp1
		clr KeyboardIn
		ldi temp1,0b11111111
		out GIFR, temp1				;INTF1:0 lschen
		ldi temp1,0b01000000		;INT0 freigeben,INT1 sperren
		out GICR, temp1		
		pop temp1
		reti





;*******************************************************************************
				

;.include "C:\Programme\Atmel\AVR Tools\AvrStudio4\PID Regler\PID SubRoutinen.asm"
.include "C:\Programme\Atmel\AVR Tools\AvrStudio4\Math\Mathematik.asm"
.include "C:\Programme\Atmel\AVR Tools\AvrStudio4\LCD\LCD Routinen.asm"
.include "C:\Programme\Atmel\AVR Tools\AvrStudio4\Math\konvert.asm"
.include "C:\Programme\Atmel\AVR Tools\AvrStudio4\PID Regler\Keyboard.asm"
;.include "C:\Programme\Atmel\AVR Tools\AvrStudio4\PID Regler\PID IntRoutinen.asm"


tabelle1:
.db	"  LCD-Testprogramm  "
;    12345678901234567890

Werte: 	.db  "Eingabe:  nW:",3,0, 	;15 Bytes lang
	   	.db  "Kp:       aW:",3,1, 
		.db	 "Ki:       aW:",3,2,
		.db  "Kd:       aW:",3,3,
		.db  "DiffMin:  aW:",3,4,
		.db  "MaxWert:  aW:",3,5,
		.db  "MinWert:  aW:",3,6
		
		;    

